Package com.complexible.stardog.metadata

# Class MetaProperties

java.lang.Object
com.complexible.stardog.metadata.MetaProperties

public final class MetaProperties extends Object
This class acts as the registry of valid Stardog options and provides convenience functions.

Since:
  0.9
Version:
  4.0
Author:
  Evren Sirin, Michael Grove

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Predicate<MetaProperty<?>>`
  `CREATABLE`
  Predicate that the returns `true` if the given option is creatable.
  `static final com.google.common.collect.Ordering<MetaProperty<?>>`
  `NAME_ORDERING`
  Ordering on the name of options
  `static final Predicate<MetaProperty<?>>`
  `WRITABLE`
  Predicate that the returns `true` if the given option is writable.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Iterable<MetaProperty<?>>`
  `allProperties()`
  Returns the set of all valid Stardog options.
  `static Metadata`
  `combine(Metadata... theOptionsArray)`
  Combines the given multiple options instances one options instance.
  `static Iterable<ConfigProperty<?>>`
  `configProperties(Iterable<MetaProperty<?>> theProperties)`
  `static boolean`
  `contains(MetaProperty<?> theOption)`
  Returns `true` if the given option is contained in the set of all valid Stardog options.
  `static boolean`
  `contains(String theName)`
  Returns `true` if there is a option with the given name in the set of all valid Stardog options.
  `static Iterable<MetaProperty<?>>`
  `databaseProperties()`
  `static Metadata`
  `defaults(Iterable<MetaProperty<?>> theStardogOptions)`
  Returns a new option map that contains explicit mapping for each given option to its `default value`.
  `static Iterable<MetaProperty<?>>`
  `diskProperties()`
  `static Metadata`
  `filter(Metadata theOptions, Predicate<MetaProperty<?>> theFilter)`
  Returns a new option map which contains explicit mappings only from those options that satisfy the given filter.
  `static <T> MetaProperty<T>`
  `get(String name)`
  `static Iterable<MetaProperty<?>>`
  `indexProperties()`
  `static Iterable<InfoProperty<?>>`
  `infoProperties(Iterable<MetaProperty<?>> theProperties)`
  `static Iterable<MetaProperty<?>>`
  `memoryProperties()`
  `static com.complexible.stardog.metadata.PartitionedMetadata`
  `partition(Metadata theOptions, Predicate<MetaProperty<?>> theFilter, boolean theMemory)`
  `static void`
  `register(Class<? extends MetaPropertyProvider> aProvider)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### WRITABLE

    public static final Predicate<MetaProperty<?>> WRITABLE
    Predicate that the returns `true` if the given option is writable.

  - ### CREATABLE

    public static final Predicate<MetaProperty<?>> CREATABLE
    Predicate that the returns `true` if the given option is creatable.

  - ### NAME_ORDERING

    public static final com.google.common.collect.Ordering<MetaProperty<?>> NAME_ORDERING
    Ordering on the name of options

- ## Method Details

  - ### get

    public static <T> MetaProperty<T> get(String name)

  - ### contains

    public static boolean contains(String theName)
    Returns `true` if there is a option with the given name in the set of all valid Stardog options.

  - ### contains

    public static boolean contains(MetaProperty<?> theOption)
    Returns `true` if the given option is contained in the set of all valid Stardog options.

  - ### allProperties

    public static Iterable<MetaProperty<?>> allProperties()
    Returns the set of all valid Stardog options.

  - ### databaseProperties

    public static Iterable<MetaProperty<?>> databaseProperties()

  - ### memoryProperties

    public static Iterable<MetaProperty<?>> memoryProperties()

  - ### diskProperties

    public static Iterable<MetaProperty<?>> diskProperties()

  - ### indexProperties

    public static Iterable<MetaProperty<?>> indexProperties()

  - ### configProperties

    public static Iterable<ConfigProperty<?>> configProperties(Iterable<MetaProperty<?>> theProperties)

  - ### infoProperties

    public static Iterable<InfoProperty<?>> infoProperties(Iterable<MetaProperty<?>> theProperties)

  - ### defaults

    public static Metadata defaults(Iterable<MetaProperty<?>> theStardogOptions)
    Returns a new option map that contains explicit mapping for each given option to its `default value`.

  - ### filter

    public static Metadata filter(Metadata theOptions, Predicate<MetaProperty<?>> theFilter)
    Returns a new option map which contains explicit mappings only from those options that satisfy the given filter.

  - ### partition

    public static com.complexible.stardog.metadata.PartitionedMetadata partition(Metadata theOptions, Predicate<MetaProperty<?>> theFilter, boolean theMemory)

  - ### combine

    public static Metadata combine(Metadata... theOptionsArray)
    Combines the given multiple options instances one options instance. If there are duplicate options in the given arguments the value that appears in the last options instance wins.

  - ### register

    public static void register(Class<? extends MetaPropertyProvider> aProvider)